function movecommand(ox,oy,dir_,player_)
	local p = {}
	
	local player = 1
	
	if (player_ ~= nil) then
		player = player_
	end
	
	if (player == 1) then
		p = findfeature(nil,"is","you")
	elseif (player == 2) then
		p = findfeature(nil,"is","you2")
	end
	
	if (dir_ ~= nil) then
		currdir = dir_
	else
		currdir = 4
	end
	
	local allplayers = {}
	
	if (p ~= nil) then
		for a,b in ipairs(p) do
			local players = findall(b)
			
			for i,v in ipairs(players) do
				table.insert(allplayers, v)
				
				local unit = mmf.newObject(v)
				local x,y,dir = unit.values[XPOS],unit.values[YPOS],unit.values[DIR]
				
				if (unit.values[MOVED] == 0) and (issleep(v) == false) then
					move(v,ox,oy,dir_)
					MF_mapsound()
				end
			end
		end
	end
	
	doupdate()
	
	if (#allplayers > 0) then
		block(allplayers,true)
	end
	
	if (dir_ ~= nil) then
		MF_mapcursor(ox,oy,dir_)
	end
end

function move(unitid,ox,oy,dir_,force_,specialrule)
	local unit = mmf.newObject(unitid)
	local x,y,dir = unit.values[XPOS],unit.values[YPOS],unit.values[DIR]
	local name = unit.strings[UNITNAME]
	local thistype = unit.strings[UNITTYPE]
	
	local movesuccess = false
	
	local force = false
	
	if (force_ ~= nil) then
		force = force_
	end
	
	if (thistype == "text") then
		name = "text"
	end
	
	if (dir_ ~= nil) then
		dir = dir_
		--unit.values[DIR] = dir
	end
	
	if (ox ~= 0) or (oy ~= 0) then
		local hm,hmids = check(unitid,ox,oy,dir,nil,nil,specialrule)
		local backhm,backhmids = check(unitid,0-ox,0-oy,dir)
		local done = false
		local weak = hasfeature(name,"is","weak",unitid)
		local swapper = hasfeature(name,"is","swap",unitid)
		local swap = findfeatureat(nil,"is","swap",x+ox,y+oy)
		local eat = hasfeature(name,"eat",nil,unitid)
		
		if (specialrule == 2) then
			if (x+ox > 0) and (x+ox < roomsize-1) and (y+oy > 0) and (y+oy < roomsize-1) then
				hm = 0
			end
		end
		
		if (specialrule == 1) then
			hm = 0
		end

		while (done == false) do
			if (hm == 0) then
				if (swapper ~= nil) then
					local swaptargets = findallhere(x+ox,y+oy)
					
					if (#swaptargets > 0) then
						for a,b in ipairs(swaptargets) do
							--update(b,x,y)
							addaction(b,{"update",x,y},force)
						end
					end
				end
				
				if (swap ~= nil) then
					for a,b in ipairs(swap) do
						--update(b,x,y)
						addaction(b,{"update",x,y},force)
					end
				end
				
				if (done == false) then
					if (unit.values[PUSHED] ~= dir) or force then
						--update(unitid,x+ox,y+oy,dir)
						addaction(unitid,{"update",x+ox,y+oy,dir},force)
						movesuccess = true
						
						local sticky = hasfeature(name,"is","stick",unitid)
						if (sticky ~= nil) then
							for a=1,4 do
								local drs = ndirs[a]
								local sox = drs[1]
								local soy = drs[2]
								
								local stickhere = findfeatureat(nil,"is","stick",x+sox,y+soy)
								
								if (stickhere ~= nil) then
									for c,d in ipairs(stickhere) do
										local sunit = mmf.newObject(d)
										if (sunit.values[MOVED] == 0) then
											move(d,ox,oy,dir)
										end
									end
								end
							end
						end
						
						if (backhm > 2) or (backhm < 0) then
							backhm = move(backhm,ox,oy,dir,false,1)
							
							if (#backhmids > 1) then
								for c,d in ipairs(backhmids) do
									if (d ~= backhm) then
										--update(d,x,y,dir)
										addaction(d,{"update",x,y,dir},force)
									end
								end
							end
						elseif (backhm == 2) then
							emptymove(x-ox,y-oy,ox,oy,dir,1)
						end
						
						unit.values[PUSHED] = dir
					end
					
					done = true
					
					if (unit.values[TILING] == 2) then
						unit.values[VISUALDIR] = ((unit.values[VISUALDIR] + 1) + 4) % 4
						--unit.direction = unit.values[DIR] * 8 + unit.values[VISUALDIR]
					end
				end
			elseif (hm > 1) or (hm < 0) then
				local hmunit = {}
				local hmx,hmy = x + ox,y + oy
				
				if (hm ~= 2) then
					hmunit = mmf.newObject(hm)
					hmx,hmy = hmunit.values[XPOS],hmunit.values[YPOS]
				end
				
				if (swapper == nil) then
					if (swap ~= nil) then
						for i,v in ipairs(swap) do
							if (v == hm) then
								local thishm = hm
								hm = 0
								
								if (#hmids > 1) then
									for c,d in ipairs(hmids) do
										if (d == v) then
											table.remove(hmids, c)
										end
									end

									hm = hmids[1]
								elseif (#hmids == 1) and (hmids[1] ~= v) then
									hm = hmids[1]
								end
							end
						end
					end
					
					if (hm > 1) or (hm < 0) then
						if (x + ox == hmx) and (y + oy == hmy) then
							if (hm ~= 2) then
								local hmunit = mmf.newObject(hm)
								
								if (hmunit.values[MOVED] == 0) or ((hmunit.values[MOVED] == 1) and (hmunit.values[DIR] ~= dir)) then
									hm = move(hm,ox,oy,dir)
								else
									hm = 0
								end
								
								if (#hmids > 1) and (hm == 0) then
									for c,d in ipairs(hmids) do
										if (d ~= hm) then
											--update(d,hmx+ox,hmy+oy,dir)
											addaction(d,{"update",hmx+ox,hmy+oy,dir},force)
										end
									end
								end
								
								if (hm ~= 1) then
									MF_sound(1)
								end
							else
								hm = emptymove(hmx,hmy,ox,oy,dir,0)
								
								if (hm ~= 1) then
									MF_sound(1)
								end
							end
						end
					end
				else
					hm = 0
				end
			else
				done = true
				local swapper = hasfeature(name,"is","swap",unitid)
				local swap = findfeatureat(nil,"is","swap",x+ox,y+oy)
				
				if (swapper ~= nil) then
					local swaptargets = findallhere(x+ox,y+oy)
					
					if (#swaptargets > 0) then
						for a,b in ipairs(swaptargets) do
							--update(b,x,y)
							addaction(b,{"update",x,y},force)
							hm = 0
							done = false
						end
					end
				end
				
				if (swap ~= nil) then
					for a,b in ipairs(swap) do
						local thishm = hm
						hm = 0
						
						if (#hmids > 1) then
							for c,d in ipairs(hmids) do
								if (d == b) then
									table.remove(hmids, c)
								end
							end

							hm = hmids[1]
						elseif (#hmids == 1) and (hmids[1] ~= b) then
							hm = 1
						else
							hm = 0
							--update(b,x,y)
							addaction(b,{"update",x,y},force)
							done = false
						end
					end
				end
				
				if (hm == 1) and (unit.values[DIR] ~= dir) then
					--updatedir(unitid,dir)
					--addaction(unitid,{"updatedir",dir})
				end
			end
		end
		
		if (hm == 1) and (weak ~= nil) and (issafe(unitid) == false) and (specialrule ~= 4) then
			if (unit.values[MOVED] == 0) then
				delete(unitid,4)
				hm = 0
			end
		end
		
		if (movesuccess == false) and (unit.values[DIR] ~= dir) then
			addaction(unitid,{"tryupdatedir",dir},force)
		end
		
		return hm
	end
end
	
function check(unitid,ox,oy,dir,x_,y_,specialrule_)
	local unit = {}
	local x,y = 0,0
	local unitname = ""
	local specialrule = 0
	local results = {}
	
	if (specialrule_ ~= nil) then
		specialrule = specialrule_
	end
	
	if (unitid ~= 2) then
		unit = mmf.newObject(unitid)
		x,y = unit.values[XPOS],unit.values[YPOS]
		unitname = unit.strings[UNITNAME]
		
		if (unit.strings[UNITTYPE] == "text") then
			unitname = "text"
		end
	else
		unitname = "empty"
		x = x_
		y = y_
	end
	
	local result_ = findobstacle(x+ox,y+oy)
	local final = 0
	local truefinal = 0
	
	local emptypush = findfeature("empty","is","push")
	local emptypull = findfeature("empty","is","pull")
	local emptystop = findfeature("empty","is","stop")
	
	local eatempty = hasfeature(unitname,"eat","empty",unitid)
	
	local imyou = hasfeature(unitname,"is","you",unitid) or hasfeature(unitname,"is","you2",unitid)
	
	local pull = 0
	local drs = ndirs[dir + 1]
	local dirox = drs[1]
	local diroy = drs[2]
	
	if (dirox ~= ox) or (diroy ~= oy) then
		pull = 1
	end
	
	if (#result_ > 0) then
		for i,v in ipairs(result_) do
			local result = v
			if (result > 1) or (result < -1) then
				local resultunit = mmf.newObject(result)
				local type = resultunit.strings[UNITTYPE]
				local name = resultunit.strings[UNITNAME]
				
				if (type == "text") then
					name = type
				end
				
				local ispush = hasfeature(name,"is","push",result)
				local isstop = hasfeature(name,"is","stop",result)
				local ispull = hasfeature(name,"is","pull",result)
				local isyou = hasfeature(name,"is","you",result) or hasfeature(name,"is","you2",result)
				local ismove = hasfeature(name,"is","move",result)
				
				local isweak = hasfeature(name,"is","weak",result) or hasfeature(unitname,"is","weak",unitid)
				
				if (type == "text") and (ispush == nil) then
					--ispush = "done"
				end
				
				if (name == "level") and (isstop ~= nil) and (resultunit.values[COMPLETED] == -1) then
					isstop = nil
				end
				
				if (pull == 0) and (isweak == nil) then
					local doors = findfeature(nil,"is","shut")
					local keys = findfeature(nil,"is","open")
					local eats = hasfeature(unitname,"eat",name,result)
					local door = 0
					local key = 0
					
					if (eats ~= nil) then
						if (issafe(result) == false) then
							MF_particles("destroy",resultunit.values[XPOS],resultunit.values[YPOS],15,0,3)
							delete(result,3)
							result = 0
							ispush,isstop,ispull,isyou,ismove = nil,nil,nil,nil,nil
							doors,keys = nil,nil
						end
					end
					
					if (doors ~= nil) and (keys ~= nil) and (specialrule ~= 1) then
						local unlocked = false
						
						print("hallo")
						
						for a,b in ipairs(doors) do
							if (unitname == b[1]) and (unitid ~= 2) then
								if testcond(b[2],unitid) then
									door = unitid
								end
							end
							
							if (name == b[1]) then
								if testcond(b[2],result) then
									door = v
								end
							end
						end
						
						for a,b in ipairs(keys) do
							if (unitname == b[1]) and (unitid ~= 2) then
								if testcond(b[2],unitid) then
									key = unitid
								end
							end
							
							if (name == b[1]) then
								if testcond(b[2],result) then
									key = v
								end
							end
						end
						
						if (door ~= 0) and (key ~= 0) and (door ~= -1) and (key ~= -1) and (door ~= key) then
							if (issafe(door) == false) then
								if (door == unitid) then
									MF_particles("unlock",x,y,15,2,4)
								elseif (door == v) then
									MF_particles("unlock",resultunit.values[XPOS],resultunit.values[YPOS],15,2,4)
								end
								delete(door,3)
								unlocked = true
								result = 0
								--MF_alert("unlock:" .. name .. ", " .. unitname)
							end
							
							if (issafe(key) == false) then
								if (key == unitid) then
									MF_particles("unlock",x,y,15,2,4)
								elseif (key == v) then
									MF_particles("unlock",resultunit.values[XPOS],resultunit.values[YPOS],15,2,4)
								end
								delete(key,0)
								unlocked = true
								result = 0
								--MF_alert("unlock")
							end
						end
						
						if unlocked then
							MF_sound(3)
						end
					end
				end
				
				if ((ispush ~= nil) and (pull == 0)) or ((ispull ~= nil) and (pull == 1)) then
					if (v ~= -1) then
						final = result
					end
				else
					if (isstop ~= nil) or ((ispull ~= nil) and (pull == 0)) then
						final = 1
					end
				end

				if ((final >= 1) or (final < -1)) and (isyou ~= nil) and ((ispush ~= nil) or ((imyou ~= nil) and (isstop ~= nil))) and (pull == 0) then
					final = result
				end
				
				if ((final >= 1) or (final < -1)) and (ismove ~= nil) and ((isstop ~= nil) or (ispush ~= nil)) then
					--final = result
				end
			end
			
			if (v == -1) then
				final = 1
			end
			
			if (final > 2) or (final < -1) then
				table.insert(results, final)
			elseif (final == 1) then
				results = {}
				truefinal = 1
			end
		end
	end
	
	if (final == 0) and (#result_ == 0) then
		if (emptystop ~= nil) then
			local doit = false
			
			for m,n in ipairs(emptystop) do
				local conds = n[2]
				if testcond(conds,2,x+ox,y+oy) then
					doit = true
				end
			end
			
			if doit then
				if (eatempty == nil) or (pull == 1) then
					final = 1
				else
					MF_particles("destroy",x+ox,y+oy,5,0,3)
				end
			end
		end
		
		if (emptypull ~= nil) and (pull == 0) and (specialrule ~= 1) then
			local doit = false
			
			for m,n in ipairs(emptypull) do
				local conds = n[2]
				if testcond(conds,2,x+ox,y+oy) then
					doit = true
				end
			end
			
			if doit then
				if (eatempty == nil) or (pull == 1) then
					final = 1
				else
					MF_particles("destroy",x+ox,y+oy,5,0,3)
				end
			end
		end
			
		
		if (emptypush ~= nil) then
			local doit = false
			
			for m,n in ipairs(emptypush) do
				local conds = n[2]
				if testcond(conds,2,x+ox,y+oy) then
					doit = true
				end
			end
			
			if doit then
				if (eatempty == nil) or (pull == 1) then
					final = 2
				else
					MF_particles("destroy",x+ox,y+oy,5,0,3)
				end
			end
		end
		
		if ((emptypull ~= nil) and (pull == 1)) then
			local doit = false
			
			for m,n in ipairs(emptypull) do
				local conds = n[2]
				if testcond(conds,2,x+ox,y+oy) then
					doit = true
				end
			end
			
			if doit then
				final = 2
			end
		end
	end
	
	if (truefinal == 1) then
		final = 1
	end

	return final,results
end

function emptymove(x,y,ox,oy,dir,pull,specialrule)
	local hm = 0
	local backhm = 0

	if (pull == 1) then
		backhm = check(2,0-ox,0-oy,dir,x,y)
	else
		hm = check(2,ox,oy,dir,x,y,specialrule)
	end
	
	local done = false
	
	local newx,newy = x+ox,y+oy
	
	while (done == false) do
		if (hm == 0) then
			done = true
			
			if (backhm > 1) or (backhm < 0) then
				if (backhm == 2) then
					backhm = emptymove(x-ox,y-oy,ox,oy,dir,1)
				else
					backhm = move(backhm,ox,oy,dir,false,1)
				end
			end
		elseif (hm > 1) or (hm < 0) then
			if (hm == 2) then
				hm = emptymove(newx,newy,ox,oy,dir,0)
			else
				hm = move(hm,ox,oy,dir)
			end
		elseif (hm == 1) then
			done = true
		end
	end

	return hm
end